WebM Codec SDK

Data Structures | Macros | Typedefs
vpx_frame_buffer.h File Reference

Describes the decoder external frame buffer interface. More...

`#include "./vpx_integer.h"`

Go to the source code of this file.

## Data Structures
struct | vpx_codec_frame_buffer
| External frame buffer. More...

## Macros
#define | VPX_MAXIMUM_WORK_BUFFERS 8
| The maximum number of work buffers used by libvpx. Support maximum 4 threads to decode video in parallel. Each thread will use one work buffer. TODO(hkuang): Add support to set number of worker threads dynamically.
#define | VP9_MAXIMUM_REF_BUFFERS 8
| The maximum number of reference buffers that a VP9 encoder may use.

## Typedefs
typedef struct vpx_codec_frame_buffer | vpx_codec_frame_buffer_t
| External frame buffer.
typedef int(* | vpx_get_frame_buffer_cb_fn_t) (void *priv, size_t min_size, vpx_codec_frame_buffer_t *fb)
| get frame buffer callback prototype
typedef int(* | vpx_release_frame_buffer_cb_fn_t) (void *priv, vpx_codec_frame_buffer_t *fb)
| release frame buffer callback prototype

## Detailed Description

Describes the decoder external frame buffer interface.

## Typedef Documentation

## ◆ vpx_codec_frame_buffer_t

typedef struct vpx_codec_frame_buffer vpx_codec_frame_buffer_t

External frame buffer.

This structure holds allocated frame buffers used by the decoder.

## ◆ vpx_get_frame_buffer_cb_fn_t

typedef int(* vpx_get_frame_buffer_cb_fn_t) (void *priv, size_t min_size, vpx_codec_frame_buffer_t *fb)

get frame buffer callback prototype

This callback is invoked by the decoder to retrieve data for the frame buffer in order for the decode call to complete. The callback must allocate at least min_size in bytes and assign it to fb->data. The callback must zero out all the data allocated. Then the callback must set fb->size to the allocated size. The application does not need to align the allocated data. The callback is triggered when the decoder needs a frame buffer to decode a compressed image into. This function may be called more than once for every call to vpx_codec_decode. The application may set fb->priv to some data which will be passed back in the vpx_image_t and the release function call. |fb| is guaranteed to not be NULL. On success the callback must return 0. Any failure the callback must return a value less than 0.

Parameters

  [in] | priv | Callback's private data
  [in] | min_size | Size in bytes needed by the buffer
  [in,out] | fb | Pointer to vpx_codec_frame_buffer_t

## ◆ vpx_release_frame_buffer_cb_fn_t

typedef int(* vpx_release_frame_buffer_cb_fn_t) (void *priv, vpx_codec_frame_buffer_t *fb)

release frame buffer callback prototype

This callback is invoked by the decoder when the frame buffer is not referenced by any other buffers. |fb| is guaranteed to not be NULL. On success the callback must return 0. Any failure the callback must return a value less than 0.

Parameters

  [in] | priv | Callback's private data
  [in] | fb | Pointer to vpx_codec_frame_buffer_t